var timeout = 3.0;	// sec
var timerID;
var interval = 1*60*1000;	// ms
var scanButton;
var scanners = new Array;

function init()
{
	if (window.widget) {
		widget.onshow = onShow;
		widget.onhide = onHide;
	}

	var i;
	var lis = document.getElementById("hosts").getElementsByTagName("li");
	for(i = 0; i < lis.length; i++)
		scanners.push(new Scanner(i));
	LOG__("scanners.length:" + scanners.length);

	scanButton = new AppleGlassButton(document.getElementById("scanButton"), "Scan", scan);

	setTimeout("scan()", 100);
	timerID = setInterval("scan()", interval);
}

function onShow() {
	clearInterval(timerID);
	scan();
	timerID = setInterval("scan()", interval);
}

function onHide() {
	clearInterval(timerID);
}

function scan()
{
	var i;
	for(i = 0; i < scanners.length; i++)
		scanners[i].start();
}

function Scanner(myNumber) {
	LOG__("Object: Scanner");
	var i;
	var lis = document.getElementById("hosts").getElementsByTagName("li");
	var li = lis[myNumber];
	var spans = li.getElementsByTagName("span");

	this.li = li;
	for (i=0; i < spans.length; i++) {
		if (spans[i].className == "hostIP")
			this.ip = spans[i].innerText;
		if (spans[i].className == "hostName")
			this.name = spans[i].innerText;
	}
	this.commandLine = "/sbin/ping -t " + timeout + " " + this.ip;
}

Scanner.prototype.start = function() {
	LOG__("Scanner.start");
	LOG__("commandLine:" + this.commandLine);

	this.li.style.textDecoration = "underline";

	if(this.command != null)
		this.command.cancel();

	var localThis = this;
	this.command = widget.system(this.commandLine, function(){ localThis.end(); });
	this.command.onreadoutput = function(str){ localThis.read(str); }
}

Scanner.prototype.read = function(str) {
	LOG__("Scanner.read");
	var time, loss;

	if (str.match(/time=([\d\.]+) ms$/)) {
		this.command.cancel();
		time = RegExp.$1 - 0;

		LOG__("time:" + time + "ms");
		this.li.style.textDecoration = "none";
		this.li.setAttribute("title", time + "ms");
		this.li.style.opacity = 1.0;
	}

	if (str.match(/(\d{1,3})% packet loss/)) {
		this.command.cancel();
		loss = RegExp.$1 - 0;

		LOG__("loss:" + loss + "%");
		if (100 <= loss) {
			this.li.style.textDecoration = "none";
			this.li.setAttribute("title", "No connection");
			this.li.style.opacity = 0.15;
		}
	}
}

Scanner.prototype.end = function() {
	LOG__("Scanner.end");
}

// ================================================
// Debugging
// ================================================
function LOG__(arg) {
//	alert(arg);
}

